#ifndef EFL_GENERATED_EVAS_LINE_HH
#define EFL_GENERATED_EVAS_LINE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_line.eo.h"
}

#include "evas_object.eo.hh"

namespace evas {

struct line;

}

namespace eo_cxx {

namespace evas {

struct line
{
   /// @brief Retrieves the coordinates of the end points of the given evas line object.
   /// second end point.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_) const;


   /// @brief @since 1.8
   ///
   /// Sets the coordinates of the end points of the given evas line object.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_LINE_CLASS);
   }

   operator ::evas::line() const;
   operator ::evas::line&();
   operator ::evas::line const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas::line*() const { return static_cast<::evas::line*>(static_cast<D const*>(this)->p); }
      operator ::evas::line const*() const { return static_cast<::evas::line const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas::line const*() const { return static_cast<::evas::line const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace evas {

struct line
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
      , ::eo_cxx::evas::common_interface
      , ::eo_cxx::evas::object
{
   line(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : line(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit line(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit line(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   line(line const& other)
      : line(eo_ref(other._eo_ptr()))
   {}

   ~line() {}

   /// @brief Retrieves the coordinates of the end points of the given evas line object.
   /// second end point.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_) const;


   /// @brief @since 1.8
   ///
   /// Sets the coordinates of the end points of the given evas line object.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_LINE_CLASS);
   }

   struct address_of
      : ::eo_cxx::evas::line::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::eo_cxx::evas::object::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas::line* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas::line::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas::object::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas::line const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_LINE_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas::line) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas::line>::value, "");

}

inline void evas::line::xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_line_xy_get(x1_, y1_, x2_, y2_));
}


inline void evas::line::xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_line_xy_set(x1_, y1_, x2_, y2_));
}


inline void eo_cxx::evas::line::xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_line_xy_get(x1_, y1_, x2_, y2_));
}


inline void eo_cxx::evas::line::xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_line_xy_set(x1_, y1_, x2_, y2_));
}


inline ::eo_cxx::evas::line::operator ::evas::line() const
{
   return *static_cast<::evas::line const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas::line::operator ::evas::line&()
{
   return *static_cast<::evas::line*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas::line::operator ::evas::line const&() const
{
   return *static_cast<::evas::line const*>(static_cast<void const*>(this));
}

template <typename T>
void evas_line_xy_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_)
{
   try
      {
         static_cast<T*>(self->this_)->xy_get(x1_, y1_, x2_, y2_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_line_xy_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_)
{
   try
      {
         static_cast<T*>(self->this_)->xy_set(x1_, y1_, x2_, y2_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas::line >
{
   template <typename T>
   struct type
         : virtual operations< ::evas::object >::template type<T>
   {
      virtual void xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_line_xy_get(x1_, y1_, x2_, y2_));
      }

      virtual void xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_line_xy_set(x1_, y1_, x2_, y2_));
      }

   };
};


template<>
struct operation_description_class_size< ::evas::line >
{
   static const int value = 2 + operation_description_class_size<::evas::object >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas::line>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::evas_line_xy_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_obj_line_xy_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::evas_line_xy_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_obj_line_xy_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::object>(), &ops[2]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas::line >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas::line, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas::line>)
{
   return (EVAS_LINE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_LINE_HH

